class "shipui" {
	x = 0, y = 0, i = 1
}

function shipui:__init(i, n, name, char)
	self.x = 4
	self.y = 22
	self.num = i
	self.maxhp = n
	self.colors = colors
	self.name = name
	self.graphic = char.graphic
	self.colorable = colorable
	self.powid = 1

	self.checksForFade =
	{
		"enemies",
		"boss",
		"bullets",
		"phoenixfire",
		"shieldparticles",
		"core",
		"powerup",
		"food",
		"emances"
	}

	self.poweruptimer = 8
	self.poweruptimerMax = 8

	self.abilityuseBar = 0
	self.abilityuseBarMax = 12

	self.megacannonthing = false

	self.powerups = {"none", "none"}
	self:setData(self.powerups[1], self.powerups[2])
	self.char = char

	self.width = self.graphic:getHeight() + 62
	self.height = 40
	self.fade = 1

	self.abilityPassive = false
	if self.char.ability then
		if self.char.ability.passive then
			self.abilityPassive = true
		end
	else
		self.abilityPassive = true
	end

	--8 spaces, dawg
	self.width = 110
	
	if i == 2 then
		self.x = gameW - self.width - 4
	elseif i == 3 then
		self.y = gameH
	elseif i == 4 then
		self.x = gameW - self.width - 4
		self.y = gameH
	end
end

function shipui:updateHUD(dt)
	--bullettype cannot be none or shoop, powerup can't be none
	--well, I can't believe I fucked up my boolean logic. Also my controller would not stop vibrating. WOO.
	if (self.powerups[1] ~= "none" and self.powerups[1] ~= "shoop") or (self.powerups[2] ~= "none" or self.powerups[1] == "shoop" and self.megacannonthing) then
		self.poweruptimer = self.poweruptimer - dt
	end
end

function shipui:FadeIn()
	self.fade = 0.5
end

function shipui:FadeOut()
	self.fade = 1
end

function shipui:resetData()
	self.powerups = {"none", "none"}

	self:setData()

	self.poweruptimer = self.poweruptimerMax
	self.megacannonthing = false
end

function shipui:CheckForCollide(name)
	for j, v in pairs(objects[name]) do
		if CheckCollision(self.x, self.y, self.width, self.height, v.x, v.y, v.width, v.height) then
			self.fade = 0.5
		else 
			self.fade = 1
		end
	end
end

function shipui:draw()
	love.graphics.setFont(font3)
	love.graphics.print(self.name, self.x * scale, (self.y - font3:getHeight(name) / scale) * scale)

	if self.maxhp < 5 then
		for k = 1, self.maxhp do
			love.graphics.draw(graphics["hitpoint"], self.x * scale + font3:getWidth(self.name) + 8 * scale + (k - 1) * 12 * scale, (self.y - 13) * scale, 0, scale, scale)
		end
	else
		love.graphics.print(self.maxhp, self.x * scale + font3:getWidth(self.name) + 16 * scale + font3:getWidth(self.num), (self.y - 13) * scale)
		love.graphics.draw(graphics["hitpoint"], self.x * scale + font3:getWidth(self.name) + 8 * scale, (self.y - 13) * scale, 0, scale, scale)
	end
end

function shipui:setData(powerType)
	self.powid = self:getHUDID(self.powerups)

	if powerType == self.powerups[1] or powerType == self.powerups[2] then
		self.poweruptimer = self.poweruptimerMax
	end
end

function shipui:setBullet(bulletType)
	self.powerups[1] = bulletType

	self:setData(bulletType)
end

function shipui:setPowerup(powerupType)
	self.powerups[2] = powerupType

	self:setData(powerupType)
end

function shipui:addAbilityBar()
	if self.abilityPassive or self.poweruptimer < self.poweruptimerMax then
		return
	end

	self.abilityuseBar = math.min(self.abilityuseBar + 1, self.abilityuseBarMax)
end

function shipui:useSpecial()
	self.abilityuseBar = 0
end

function shipui:isAbilityFull()
	return (self.abilityuseBar == self.abilityuseBarMax)
end

function shipui:checkExceptions(v)
	if v == "oneup" then
		return false 
	end
	return true
end

function shipui:getHUDID(powers)
	local bull, pow = unpack(powers)

	if bull == "none" and pow == "none" then
		return 1
	elseif bull ~= "none" and pow == "none" then
		return powerup:getQuad(bull)	
	elseif pow ~= "shield" and pow ~= "none" and pow ~= "time" then
		return powerup:getQuad(pow)
	elseif pow == "shield" and pow ~= "time" then
			if bull == "shotgun" then
				return 12
			elseif bull == "shoop" then
				return 14
			elseif bull == "laser" then
				return 15
			elseif bull == "antiscore" then
				return 16 
			elseif bull == "nobullets" then
				return 17
			end
			return 5
	elseif pow == "time" and pow ~= "shield" then
		if bull == "shotgun" then
			return 18
		elseif bull == "shoop" then
			return 19
		elseif bull == "laser" then
			return 20
		elseif bull == "antiscore" then
			return 21 
		elseif bull == "nobullets" then
			return 22
		end
		return 3
	elseif bull == "none" and pow == "special" then
		return 23
	end
end